//+------------------------------------------------------------------+
//|                                         two_dimensional_data.mqh |
//|                                      Copyright 2017, nicholishen |
//|                         https://www.forexfactory.com/nicholishen |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, nicholishen"
#property link      "https://www.forexfactory.com/nicholishen"
#property strict

#include <Arrays\ArrayObj.mqh>
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
template<typename T>
class TwoDimensionalData 
{
   template<typename P>
   class objvector:public CArrayObj
   {
      public: P operator[](const int i){ return At(i);}
   };
   class DataEntry : public CObject
   {
      T     m_data;
     public:
            DataEntry():m_data(NULL){}
      T     Get()       const { return m_data; }
      void  Set(const T data) { m_data=data;   }
   };
   objvector<objvector<DataEntry*>*> m_list;
   int         m_total_d2;
public:
               TwoDimensionalData():m_total_d2(0){}
   bool        Get(T &value,const int i,const int j);
   T           Get(const int i,const int j);
   bool        Set(const T value,const int i,const int j); 
   int         Total_D1();
   int         Total_D2();
};
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
template<typename T>
bool TwoDimensionalData::Get(T &value,const int i,const int j)
{
   objvector<DataEntry*> *obv = m_list[i];
   if(obv != NULL)
   {
      DataEntry *data = obv[j];
      if(data != NULL)
      {
         value = data.Get();
         return true;
      }
   }
   return false;
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
template<typename T>
T TwoDimensionalData::Get(const int i,const int j)
{
   T value;
   if(Get(value,i,j))
      return value;
   return NULL;
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
template<typename T>
bool TwoDimensionalData::Set(const T value,const int i,const int j)
{
   if(j>=m_total_d2)
   {
      for(int k=0;k<m_list.Total();k++)
         while(m_list[k].Total()<=j)
            if(!m_list[k].Add(new DataEntry))
               return false;
      m_total_d2=j+1;
   }
   while(m_list.Total() <= i)
   {
      objvector<DataEntry*> *obv = new objvector<DataEntry*>;
      if(!m_list.Add(obv))
         return false;
      while(obv.Total() < m_total_d2)
         if(!obv.Add(new DataEntry))
            return false;
   }
   objvector<DataEntry*> *obv = m_list[i];
   if(obv != NULL)
   {
      DataEntry *data = obv[j];
      if(data != NULL)
      {
         data.Set(value);
         return true;
      }
   }
   return false;
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
template<typename T>
int TwoDimensionalData::Total_D1()
{
   return m_list.Total();
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
template<typename T>
int TwoDimensionalData::Total_D2()
{
   return m_total_d2;
}